<?session_start();

//RESTRICCIÓN DE ACCESO A TRABAJADOR (ACCESO INDIVIDUAL)
if (isset($_SESSION['tipousuario']))
		{if ($_SESSION['tipousuario']=='1')
		header ('location:menu_personal.php');
		}

if  (trim($_SESSION['nombre_validar'])=='') header ('location:index.php');
include ("fphp.php");
$enlace=cargar_conexion();
$consulta=mysqli_query($enlace,"select * from periodo where id='".$_SESSION['id_validar']."' order by nomina,periodo desc limit 1");
if (mysqli_num_rows($consulta)!=0){
	$row=mysqli_fetch_array($consulta);
	$per=mostrar_fecha($row['desde']).' al '.mostrar_fecha($row['hasta'])." (Nom:".$row['nomina'].")";
} else $per='';
////////////////////////////////// generando FAOV
if ($_POST['treporte']==1) {
?>
<html>
<head>
 <meta charset="UTF-8">
</head>
<body>
<?php


		$query='';
		if ($_POST['nomina']!='') $query .= "  ";
		if ($_POST['gerencia']!='') $query .= " and personal.gerencia = '".$_POST['gerencia']."' ";
		if ($_POST['division']!='') $query .= " and personal.division = '".$_POST['division']."' ";
		if ($_POST['departamento']!='') $query .= " and personal.departamento = '".$_POST['departamento']."' ";
		$consulta = "select * from personal where id='".$_SESSION['id_validar']."'  AND (fechae>='".substr($_POST['per1'],0,10)."' OR fechae='0000-00-00') AND status!='S'

		$query order by codigo"; //and status<>'I'
		$resultado = mysqli_query($enlace,$consulta) or die('verificaci&oacute; del c&oacute;digo fall&oacute;: ' . mysqli_error($enlace));
		$data=array();

		//GeneraciÃ³n de archivo
		$fecha_lote_otros = date("dmY-His"); //Fecha a imprimir en archivo (Fecha sin ceros a la izquierda)
		$fileName = "pago_faov-".$fecha_lote_otros.".txt";
		$fo = "faov_txt/".$fileName;
		$fileReporte = fopen($fo,"w+");

		while ($row=mysqli_fetch_array($resultado)) {

			$nac=(strtoupper($row['nacionalidad']) != 'E' ? 'V' : 'E');
			if ($nac!='V') $nac='E';
			if ($row['status']=='C') $fechae='';
			else {
				if ($row['fechae']=='0000-00-00' || $row['fechae'] > substr($_POST['per2'],0,10)) $fechae='';
				else $fechae=$row['fechae'];
			}

			///consulto mayores de 60 años
			/*
			$consultaEdad="Select codigo from personal where fechan>='1961-11-09'  AND status!='I' AND nomina='".substr($_POST['per1'],13,3)."' ";
			$resultadoEdad = mysqli_query($enlace,$consultaEdad) or die ("no se pudo realizar la consulta...".$consultaEdad.'='.mysqli_error($enlace));
			if (mysqli_num_rows($resultadoEdad)!=0) {
			   $rowEdad=mysqli_fetch_array($resultadoEdad);
			   $MayorFaov=$rowEdad['codigo'];
			}
			*/

				///Busco los trabajadores y lo retenido a cada uno por RPVH
				//FROM costo_laboral AS costo_laboral JOIN personal AS personal ON
			//$consulta2="Select sum(h.monto) as total, h.cedula, c.cedula FROM historico AS h JOIN concepto_empleado AS c ON c.cedula!=h.cedula where c.cedula!=h.cedula AND h.id='".$_SESSION['id_validar']."' and h.cedula='".$row['codigo']."' and substring(h.concepto,1,1)='1' AND h.concepto!='1490' AND h.concepto!='1498' AND h.concepto!='1499' AND h.concepto!='1581' AND h.concepto!='1590' AND h.concepto!='1598' AND h.concepto!='1599' and h.nomina='".substr($_POST['per1'],13,3)."' and h.periodo>='".substr($_POST['per1'],0,3)."' and h.periodo<='".substr($_POST['per2'],0,3)."' ";


			
			$consulta2="Select sum(monto) as total from historico where historico.id='".$_SESSION['id_validar']."' and cedula='".$row['codigo']."'AND historico.tipo='A' AND substr(concepto,1,1)='1' and substr(desperiodo,15,10)>='".substr($_POST['per1'],0,10)."' and substr(desperiodo,15,10)<='".substr($_POST['per2'],0,10)."' AND concepto NOT IN('1498' ,'1499' ,'1598' ,'1599' ,'3490' ,'3498','3499','3590','3598' ,'3599','1525','1526') having sum(monto) > 0";
			$resultado2 = mysqli_query($enlace,$consulta2) or die ("no se pudo realizar la consulta...".$consulta2.'='.mysqli_error($enlace));
			///////!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			///// En este devengado se debe restar los montos de los conceptos 2064 y 2069--Miguelangel -10/01/2022
			
			   $row2=mysqli_fetch_array($resultado2);
			   $total=$row2['total'];

			$consulta22="Select sum(monto) as total from historico where historico.id='".$_SESSION['id_validar']."' and cedula='".$row['codigo']."'AND historico.tipo='D'  and substr(desperiodo,15,10)>='".substr($_POST['per1'],0,10)."' and substr(desperiodo,15,10)<='".substr($_POST['per2'],0,10)."' AND concepto IN('2064','2069')  ";
			$resultado22 = mysqli_query($enlace,$consulta22) or die ("no se pudo realizar la consulta...".$consulta22.'='.mysqli_error($enlace));
			///////!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			///// En este devengado se debe restar los montos de los conceptos 2064 y 2069--Miguelangel -10/01/2022


			   $row22=mysqli_fetch_array($resultado22);
			   $totalDed=$row22['total'];

			$total = $total - $totalDed;

			   //////////Consulta para traer lo retenido Faov en Utilidades
			
			$consulta33="Select SUM(monto) AS monto from utilidades where id='".$_SESSION['id_validar']."' and cedula='".$row['codigo']."' and concepto IN('8018','8118') and fecha>='".substr($_POST['per1'],0,10)."' and fecha<='".substr($_POST['per2'],0,10)."' ";
			$resultado33 = mysqli_query($enlace,$consulta33) or die ("no se pudo realizar la consulta...".$consulta33.'='.mysqli_error($enlace));
			   $row33=mysqli_fetch_array($resultado33);
			  $rpvhUtilidades=$row33['monto']*100;
			  

			   ///////////Consulta para traer lo retenido Faov en Vacaciones
			$consulta44="Select SUM(rpvh) as monto from vacacion where id='".$_SESSION['id_validar']."' and cedula='".$row['codigo']."' and fecha_pago>='".substr($_POST['per1'],0,10)."' and fecha_pago<= '".substr($_POST['per2'],0,10)."'  ";
			$resultado44 = mysqli_query($enlace,$consulta44) or die ("no se pudo realizar la consulta...".$consulta2.'='.mysqli_error($enlace));
			   $row44=mysqli_fetch_array($resultado44);
			   $rpvhVacaciones=$row44['monto']*100;

			  // echo "consulta pra traer el faov de vacaciones: " .$consulta44 ;
			   

			   ///////////Consulta para traer lo retenido Faov en LIQUIDACIONES
			$consulta55="Select faov as monto from liquidaciones where id='".$_SESSION['id_validar']."' and cedula='".$row['codigo']."' and fecha_retiro>='".substr($_POST['per1'],0,10)."' and fecha_retiro<= '".substr($_POST['per2'],0,10)."' ";
			$resultado55 = mysqli_query($enlace,$consulta55) or die ("no se pudo realizar la consulta...".$consulta2.'='.mysqli_error($enlace));
			   $row55=mysqli_fetch_array($resultado55);
			   $rpvhLiquidaciones=$row55['monto']*100;
			   

			  // if(floatval($total)>0){
			         $total=$total;
			         //$total.="00";
			         //$total=round(floatval($total)/0.01,2);
			         //$ingreso=substr($total,0,strlen($total)-3).substr($total,strlen($total)-2,2);




			         $ingreso=($total + $rpvhUtilidades + $rpvhVacaciones + $rpvhLiquidaciones);
					 $ingreso=number_format($ingreso,2,'','');

					 if ( $ingreso >=13000){
							$ingreso=$ingreso;
					 }
					 elseif($ingreso>0 && $ingreso < 13000) $ingreso= 13000;
			         //$ingreso=number_format($total,2,'');
			         //$ingreso=str_replace($total,".","");
			//Consulta para calcular la edad
				$consultaEdad="Select fechan from personal where id='".$_SESSION['id_validar']."' and codigo='".$row['codigo']."' ";
				$consultaEdad = mysqli_query($enlace,$consultaEdad) or die ("no se pudo realizar la consulta...".$consultaEdad.'='.mysqli_error($enlace));
				$rowEdad = mysqli_fetch_array($consultaEdad);
				$fechaNac=$rowEdad['fechan'];
				$fechaHoy= $fechaActual=date('Y-m-d');
				
				$date1=$fechaNac;
				//$date2=$fechaHoy; /// así hacia el corte de edad a la fecha del día que estaba generando el TXT  -- Miguelangel 01/11/24
				$date2 = substr($_POST['per2'],0,7)."-30" ;/// para que haga el corte al final del mes que estoy generando el TXT -- Miguelangel 01/11/24

				$dateDifference = abs(strtotime($date2) - strtotime($date1));
				$years  = floor($dateDifference / (365 * 60 * 60 * 24));
				$months = floor(($dateDifference - $years * 365 * 60 * 60 * 24) / (30 * 60 * 60 * 24));
				$days   = floor(($dateDifference - $years * 365 * 60 * 60 * 24 - $months * 30 * 60 * 60 *24) / (60 * 60 * 24));
				$edad = $years + ($months/12) + ($days/30/12);
				//echo $years." year,  ".$months." months and ".$days." days";

				if ($edad<60 && $ingreso>0 )
					{///Menos de 60 años retiene
						
						fwrite($fileReporte,$nac.",".trim($row['codigo']).",".trim($row['nombres']).",".trim($row['nombres1']).",".trim($row['apellidos']).",".trim($row['apellidos1']).",".trim($ingreso).",".substr($row['fechai'],8,2).substr($row['fechai'],5,2).substr($row['fechai'],0,4).",".substr($fechae,8,2).substr($fechae,5,2).substr($fechae,0,4));
						fwrite($fileReporte,"\r\n"); //Nueva Linea
					}

		
	}
	fclose($fileOtros);

		echo "<style>
			.regristrado{
					color: green;
					margin-left: 7%;
					font-weight: bold;
			}
		</style>";
		echo "<p class='regristrado' >Reporte generado correctamente <a href = 'generar_txt.php?specialPayment=$fileName&directory=faov_txt';>Descargar</a><p>";

		echo "<a id='link1' target='_blank' href = 'generar_txt.php?specialPayment=$fileName&directory=faov_txt';></a>";
		echo "<script> document.getElementById('link1').click();</script>";

	/*$data=implode("\n",$data);
	$arch="FAOV.txt";
	header("Content-type: text/csv;charset=UTF-8");
	header("Content-Disposition: attachment; filename=".$arch);
	header("Pragma: no-cache");
	header("Expires: 0");
	echo ($data);*/
?>
</body>
</html>
<?php
	exit();
}

?>
<html>
	<head><link rel='stylesheet' type='text/css' href='styles.css' />
	</head>
	<body>
		<?
		menu();
		?>
		<br><table border=0 cellpadding=0 cellspacing=0 width='100%'>
			<tr>
				<td  width='100%' align='left'><font size=2 color='black' face='verdana'>Empresa: <b><?echo $_SESSION['empresa_validar'];?></b>  - Per&iacute;odo: <b><font color=red><?echo $per;?></font></b>  -  Usuario: <b><?echo $_SESSION['nombre_validar'];?></b></font></td>
			</tr>
		</table><hr>
<?
	echo "<H2><center>GENERAR ARCHIVO TXT PARA CARGA AL FAOV</center></H2>";
	echo "<font face='verdana' size=2>";
	echo "<br><br><form name='entrada' action='".$_SERVER['PHP_SELF']."' target='blank' method='POST' enctype='multipart/form-data'>
	<table align='center'>";
			if ($per!='') {
					//echo "<tr><td align='righta'>Per&iacute;odo Actual:</td>
						  //<td align='left'><font color=red>".$per."</font></td>
						  //</tr>";
			}
			echo "<tr><td align='righta'>Tipo de Archivo:</td>
				<td align='left'>
					<select style='width:300px; border-radius:8px; padding:4px;'  name='treporte'>
						<option value='1'>Texto para (FAOV)</option>
		
					</select>
				</td>
				</tr>";
				//<option value='5'>Reporte INCES</option> lo saquÃ© aparte (reporte_INCES.php)
				//<option value='4'>Libro de Vacaciones</option> lo saquÃ© en un archivo aparte (reporte_vacaciones.php)
				//Miguelangel 20-04-2020

			$consulta = mysqli_query($enlace,"select * from periodo where id='".$_SESSION['id_validar']."' AND nomina=200 order by nomina,periodo DESC") or die ("select * from periodo order by nomina,periodo DESC");
			$numr = mysqli_num_rows($consulta);
			echo "<td align = ''> <font color=red>Per&iacute;odo Desde: </font></td>";
			echo "<td align = 'left'> <select style='width:300px; border-radius:8px; padding:4px;'  name = 'per1'>";
			for ($x=1;$x<=$numr;$x++) {
				$row1 = mysqli_fetch_array($consulta);
				if ($x!=1) {
					echo "<option>".$row1['desde'];
				}
			}
			echo "</select>";
			echo "</td></tr>";

			$consulta = mysqli_query($enlace,"select * from periodo where id='".$_SESSION['id_validar']."' AND nomina=200 order by nomina,periodo DESC") or die ("select * from periodo order by nomina,periodo DESC");
			$numr = mysqli_num_rows($consulta);
			echo "<td align = ''> <font color=red>Per&iacute;odo Hasta: </font></td>";
			echo "<td align = 'left'> <select style='width:300px; border-radius:8px; padding:4px;'  name = 'per2'>";
			for ($x=1;$x<=$numr;$x++) {
				$row1 = mysqli_fetch_array($consulta);
				if ($x!=1) {
					echo "<option>".$row1['hasta'];
				}
			}
			echo "</select>";
			echo "</td></tr>";

			/*
			echo "<tr>";
			$consulta="Select * from tablas where tabla=ucase('GERENCIA') and id='".$_SESSION['id_validar']."'  order by codigo,detalle";
			$consulta = mysqli_query($enlace,$consulta) or die ("no se pudo realizar la consulta...".$consulta.'='.mysqli_error($enlace));
			$resultado = mysqli_num_rows($consulta);
			echo "<td align = 'righta'> Gerencia: </td>";
			echo "<td align = 'left'> <select style='width:300px;' name = 'gerencia'><option>";
			if ($resultado != 0) {
				for ($i=0;$i<$resultado;$i++) {
					$row1 = mysqli_fetch_array($consulta);
					echo "<option width = '30%'>".$row1['codigo']." - ".$row1['detalle'];
				}
			}
			echo "</select>";
			echo "</td>";
			echo "</tr>";
			*/
			
			/*
			echo "<tr>";
			$consulta="Select * from tablas where tabla=ucase('DIVISION') and id='".$_SESSION['id_validar']."' order by codigo,detalle";
			$consulta = mysqli_query($enlace,$consulta) or die ("no se pudo realizar la consulta...".$consulta.'='.mysqli_error($enlace));
			$resultado = mysqli_num_rows($consulta);
			echo "<td align = 'righta'> Divisi&oacute;n: </td>";
			echo "<td align = 'left'> <select style='width:300px;' name = 'division'><option>";
			if ($resultado != 0) {
				for ($i=0;$i<$resultado;$i++) {
					$row1 = mysqli_fetch_array($consulta);
					echo "<option width = '30%'>".$row1['codigo']." - ".$row1['detalle'];
				}
			}
			echo "</select>";
			echo "</td>";
			echo "</tr>";
			*/

			/*
			echo "<tr>";
			$consulta="Select * from tablas where tabla=ucase('DEPARTAMENTO') and id='".$_SESSION['id_validar']."' order by codigo,detalle";
			$consulta = mysqli_query($enlace,$consulta) or die ("no se pudo realizar la consulta...".$consulta.'='.mysqli_error($enlace));
			$resultado = mysqli_num_rows($consulta);
			echo "<td align = 'righta'> Departamento: </td>";
			echo "<td align = 'left'> <select style='width:300px;' name = 'departamento'><option>";
			if ($resultado != 0) {
				for ($i=0;$i<$resultado;$i++) {
					$row1 = mysqli_fetch_array($consulta);
					echo "<option width = '30%'>".$row1['codigo']." - ".$row1['detalle'];
				}
			}
			echo "</select>";
			echo "</td>";

			echo "<tr>";*/
			echo "<td colspan='4' align='center'>";
			echo "<input name='ver' type='submit' class='boton' value='GENERAR ARCHIVO'>";
			echo "</td></tr>";
			echo "</table></form></font>";
?>

	<style>
	.boton {
		border-radius: 8px;      /* Bordes redondeados */
		padding: 8px 16px;       /* Más espacio interno */
		border: none;            /* Quita el borde feo por defecto */
		cursor: pointer;         /* Mano al pasar */
		transition: 0.2s ease;   /* Animación suave */
		}

		.boton:hover {
		transform: scale(1.03);  /* Efecto sutil al pasar el mouse */
		}

	</style>

	</body>
</html>
